from gi.repository import Gtk
import vmdisks

def chooser(dialog_name, topwin, mode=Gtk.FileChooserAction.OPEN,
            file=None, folder=None, type=None):
    fcdialog = Gtk.FileChooserDialog(dialog_name, topwin, mode,
                                     (Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL,
                                     Gtk.STOCK_OPEN, Gtk.ResponseType.ACCEPT))
    if file:
        index=0
        filename = file
        while index < len(vmdisks.get_disk_protocols()):
            if file.startswith(vmdisks.get_disk_protocols()[index]):
                filename = file[len(vmdisks.get_disk_protocols()[index]):]
                break
            index += 1
        file = filename
        fcdialog.set_filename(file)
    if folder:
        fcdialog.set_current_folder(folder)
    if mode == Gtk.FileChooserAction.SAVE:
        fcdialog.set_do_overwrite_confirmation(True)
    if type != None:
        f = Gtk.FileFilter()
        f.add_pattern("*." + type)
        fcdialog.set_filter(f)
    response = fcdialog.run()
    fcdialog.hide()
    if response == Gtk.ResponseType.ACCEPT:
        filename = fcdialog.get_filename()
        folder = fcdialog.get_current_folder()
        fcdialog.destroy()
        return (filename, folder)
    else:
        fcdialog.destroy()
        return (None, None)

